

const {ccclass,inspector, property} = cc._decorator;
@ccclass
export default class TestScene extends cc.Component{
  

    @property(cc.Node)
    leftRoot: cc.Node = null;
    
    @property(cc.Node)
    leftRun: cc.Node = null;
    
    @property(cc.Node)
    icoLeft: cc.Node = null;
    
    @property(cc.Node)
    rightRun: cc.Node = null;
    
    @property(cc.Node)
    icoRight: cc.Node = null;

    @property(cc.Node)
    btnJump: cc.Node = null;
    
    @property(cc.Node)
    btnAttack: cc.Node = null;


    onEnable(){
        cc.view.enableAutoFullScreen(true);
        this.leftRoot.on(cc.Node.EventType.TOUCH_START,this.onTouchBegan,this);
        this.leftRoot.on(cc.Node.EventType.TOUCH_MOVE,this.onTouchMoved,this);
        this.leftRoot.on(cc.Node.EventType.TOUCH_END,this.onTouchEnded,this);
        this.leftRoot.on(cc.Node.EventType.TOUCH_CANCEL,this.onTouchCancel,this);


        this.btnJump.on(cc.Node.EventType.TOUCH_START,this.onTouchJumpBegin,this);
        this.btnJump.on(cc.Node.EventType.TOUCH_END,this.onTouchJumpEnd,this);


        this.btnAttack.on(cc.Node.EventType.TOUCH_START,this.onTouchAttackBegin,this);
        this.btnAttack.on(cc.Node.EventType.TOUCH_END,this.onTouchAttackEnd,this);
    }
    onDisable(){
        this.leftRoot.targetOff(this);
    }
    onTouchBegan(event: cc.Event.EventTouch) {
        this.onTouchMoved(event);
    }

    onTouchMoved(event: cc.Event.EventTouch) {
        if(this.isTouchedBtn(this.leftRun,event) && this.icoLeft.active){
            console.log(`TestScene-> 向左走`);
            this.icoLeft.scale = 1.2;
            this.icoRight.scale = 1;
        }else if(this.isTouchedBtn(this.rightRun,event) && this.icoRight.active){
            console.log(`TestScene-> 向右走`);
            
            this.icoLeft.scale = 1;
            this.icoRight.scale = 1.2;
        }else{
            console.log(`TestScene-> 移动  未触发`);
            this.icoLeft.scale = 1;
            this.icoRight.scale = 1;
        }
    }
    onTouchEnded(event: cc.Event.EventTouch) {
        this.onTouchCancel(event);
    }
    onTouchCancel(event: cc.Event.EventTouch) {
        
        if(this.icoLeft.scale === 1 && this.icoRight.scale === 1){
            return;
        }
        this.icoLeft.scale = 1;
        this.icoRight.scale = 1;
    }

    isTouchedBtn(node: cc.Node,event: cc.Event.EventTouch){
        let location = event.getLocation();
        // @ts-ignore
        let hit = node._hitTest(location);
        return hit;
    }

    
    onTouchJumpBegin(){
        console.log(`TestScene-> 跳跃开始`);
        
    }
    onTouchJumpEnd(){
        console.log(`TestScene-> 跳跃结束`);
    }

    onTouchAttackBegin(){
        console.log(`TestScene-> 攻击开始`);
    }
    onTouchAttackEnd(){
        console.log(`TestScene-> 攻击结束`);
    }


}
